package net.minestom.server.instance;

import java.util.Arrays;

public enum Biome {

    OCEAN(0),
    DEEP_OCEAN(24),
    FROZEN_OCEAN(10),
    DEEP_FROZEN_OCEAN(50),
    COLD_OCEAN(46),
    DEEP_COLD_OCEAN(49),
    LUKEWARM_OCEAN(45),
    DEEP_LUKEWARM_OCEAN(48),
    WARM_OCEAN(44),
    DEEP_WARM_OCEAN(47),
    RIVER(7),
    FROZEN_RIVER(11),
    BEACH(16),
    STONE_SHORE(25),
    SNOWY_BEACH(26),
    FOREST(4),
    WOODED_HILLS(18),
    FLOWER_FOREST(132),
    BIRCH_FOREST(27),
    BIRCH_FOREST_HILLS(28),
    TALL_BIRCH_FOREST(155),
    TALL_BIRCH_HILLS(156),
    DARK_FOREST(29),
    DARK_FOREST_HILLS(157),
    JUNGLE(21),
    JUNGLE_HILLS(22),
    MODIFIED_JUNGLE(149),
    JUNGLE_EDGE(23),
    MODIFIED_JUNGLE_EDGE(151),
    BAMBOO_JUNGLE(168),
    BAMBOO_JUNGLE_HILLS(169),
    TAIGA(5),
    TAIGA_HILLS(19),
    TAIGA_MOUNTAINS(133),
    SNOWY_TAIGA(30),
    SNOWY_TAIGA_HILLS(31),
    SNOWY_TAIGA_MOUNTAINS(158),
    GIANT_TREE_TAIGA(32),
    GIANT_TREE_TAIGA_HILLS(33),
    GIANT_SPRUCE_TAIGA(160),
    GIANT_SPRUCE_TAIGA_HILLS(161),
    MUSHROOM_FIELDS(14),
    MUSHROOM_FIELDS_SHORE(15),
    SWAMP(6),
    SWAMP_HILLS(134),
    SAVANA(35),
    SAVANA_PLATEAU(36),
    SHATTERED_SAVANA(163),
    SHATTERED_SAVANA_PLATEAU(164),
    PLAINS(1),
    SUNFLOWER_PLAINS(129),
    DESERT(2),
    DESERT_HILLS(17),
    DESERT_LAKES(130),
    SNOWY_TUNDRA(12),
    SNOWY_MOUNTAINS(13),
    ICE_SPIKES(140),
    MOUNTAINS(3),
    WOODED_MOUTAINS(34),
    GRAVELLY_MOUNTAINS(131),
    MODIFIED_GRAVELLY_MOUNTAINS(162),
    MOUNTAIN_EDGE(20),
    BADLANDS(37),
    BADLANDS_PLATEAU(39),
    MODIFIED_BADLANDS_PLATEAU(167),
    WOODED_BADLANDS_PLATEAU(38),
    MODIFIED_WOODED_BADLANDS_PLATEAU(166),
    ERODED_BADLANDS(165),
    NETHER(8),
    THE_END(9),
    SMALL_END_ISLANDS(40),
    END_MIDLANDS(41),
    END_HIGHLANDS(42),
    END_BARRENS(43),
    VOID(127);

    private int id;

    Biome(int id) {
        this.id = id;
    }

    public static Biome fromId(int id) {
        return Arrays.stream(values()).filter(customBiome -> customBiome.id == id).findFirst().get();
    }

    public int getId() {
        return id;
    }
}
