package net.minestom.server.stat;

import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;

public enum StatisticType {

    LEAVE_GAME,
    PLAY_ONE_MINUTE,
    TIME_SINCE_DEATH,
    TIME_SINCE_REST,
    SNEAK_TIME,
    WALK_ONE_CM,
    CROUCH_ONE_CM,
    SPRINT_ONE_CM,
    WALK_ON_WATER_ONE_CM,
    FALL_ONE_CM,
    CLIMB_ONE_CM,
    FLY_ONE_CM,
    WALK_UNDER_WATER_ONE_CM,
    MINECART_ONE_CM,
    BOAT_ONE_CM,
    PIG_ONE_CM,
    HORSE_ONE_CM,
    AVIATE_ONE_CM,
    SWIM_ONE_CM,
    JUMP,
    DROP,
    DAMAGE_DEALT,
    DAMAGE_DEALT_ABSORBED,
    DAMAGE_DEALT_RESISTED,
    DAMAGE_TAKEN,
    DAMAGE_BLOCKED_BY_SHIELD,
    DAMAGE_ABSORBED,
    DAMAGE_RESISTED,
    DEATHS,
    MOB_KILLS,
    ANIMALS_BRED,
    PLAYER_KILLS,
    FISH_CAUGHT,
    TALKED_TO_VILLAGER,
    TRADED_WITH_VILLAGER,
    EAT_CAKE_SLICE,
    FILL_CAULDRON,
    USE_CAULDRON,
    CLEAN_ARMOR,
    CLEAN_BANNER,
    CLEAN_SHULKER_BOX,
    INTERACT_WITH_BREWINGSTAND,
    INTERACT_WITH_BEACON,
    INSPECT_DROPPER,
    INSPECT_HOPPER,
    INSPECT_DISPENSER,
    PLAY_NOTEBLOCK,
    TUNE_NOTEBLOCK,
    POT_FLOWER,
    TRIGGER_TRAPPED_CHEST,
    OPEN_ENDERCHEST,
    ENCHANT_ITEM,
    PLAY_RECORD,
    INTERACT_WITH_FURNACE,
    INTERACT_WITH_CRAFTING_TABLE,
    OPEN_CHEST,
    SLEEP_IN_BED,
    OPEN_SHULKER_BOX,
    OPEN_BARREL,
    INTERACT_WITH_BLAST_FURNACE,
    INTERACT_WITH_SMOKER,
    INTERACT_WITH_LECTERN,
    INTERACT_WITH_CAMPFIRE,
    INTERACT_WITH_CARTOGRAPHY_TABLE,
    INTERACT_WITH_LOOM,
    INTERACT_WITH_STONECUTTER,
    BELL_RING,
    RAID_TRIGGER,
    RAID_WIN,
    INTERACT_WITH_ANVIL,
    INTERACT_WITH_GRINDSTONE;

    private static Int2ObjectOpenHashMap<StatisticType> map = new Int2ObjectOpenHashMap();

    private int id;

    public static StatisticType fromId(int id) {
        return map.get(id);
    }

    public void setIdentifier(int id) {
        this.id = id;

        map.put(id, this);
    }

    public int getId() {
        return id;
    }
}
